#include "config-load.h"
#include "config-process.h"
#include "device.h"
#include "util.h"

#include <libubox/avl-cmp.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

bool read_config(const char *path) {
	struct json_object *config = json_object_from_file(path);
	if (!config)
		return false;

	struct avl_tree *devices = config_process(config);
	json_object_put(config);

	if (!devices)
		return false;

	device_t *dev, *tmp;
	avl_for_each_element(devices, dev, node)
		dev->type->init(dev);

	//avl_for_each_element(devices, dev, node)
	//	dev->type->release(dev);

	avl_remove_all_elements(devices, dev, node, tmp)
		dev->type->free(dev);

	free(devices);

	return true;
}
