#include "device.h"
#include "util.h"

#include <libubox/avl-cmp.h>

AVL_TREE(device_types, avl_strcmp, false, NULL);

void register_device_type(const char *name, device_type_t *device_type) {
	NODE_NAME(device_type) = (char *)name;
	avl_insert(&device_types, &device_type->node);
}

const device_type_t * get_device_type(const char *name) {
	return avl_find_element(&device_types, name, (device_type_t *)NULL, node);
}
